import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
/* eslint-disable no-loop-func */
/* eslint-disable no-unused-expressions */
import { Checkbox, FormControl, FormControlLabel, FormGroup, Grid, Radio, RadioGroup, Typography } from "@mui/material";
import React from "react";
import CreatableSelect from "react-select/creatable";
import NormalInput from "../Components/AnnoatationNormalInput";
import AnnotationInput from "../Components/AnnotationInput";
import LocalStorage from "../Components/LocalStorage";
import { ShowCount, errorSpan, fielderror, isNonMandatoryEditable, trimRule } from "../Components/ValidationCheck";
import TaskFormLabel from "./TaskFormLabel";
var Getrules = LocalStorage.get_task_rules() || {};
var editable_type = ["textArea", "dropdown", "multiSelectDropdown", "dependentDropdown", "input", "date", "checkbox", "radio", "classification", "tags", "text_annotation"];
function FormOCR(_ref) {
  var _dependent_rule_all_d, _dependent_rule_all_d2, _dependent_rule_all_d3, _ref8, _ref8$find, _String, _getDropdown_data$get, _getDropdown_data$get2, _LocalStorage$get_dro, _LocalStorage$get_dro2;
  var index = _ref.index,
    formData = _ref.formData,
    setFormData = _ref.setFormData,
    item = _ref.item,
    editable_arr = _ref.editable_arr,
    customized_column_arr = _ref.customized_column_arr,
    column_key = _ref.column_key,
    setCustomize = _ref.setCustomize,
    _ref$access_block = _ref.access_block,
    access_block = _ref$access_block === void 0 ? [] : _ref$access_block,
    invalid_show = _ref.invalid_show,
    invalidForm = _ref.invalidForm,
    original_data = _ref.original_data,
    updateForm = _ref.updateForm;
  var _ref2 = item || {},
    invalid = _ref2.invalid,
    description_labelling = _ref2.description_labelling,
    image_urls_labelling = _ref2.image_urls_labelling,
    title = _ref2.title,
    default_type = _ref2.default_type,
    display_label = _ref2.display_label,
    content = _ref2.content,
    input_type = _ref2.input_type,
    value = _ref2.value,
    other_value = _ref2.other_value,
    mandatory = _ref2.mandatory,
    history_hide = _ref2.history_hide,
    editable_data = _ref2.editable_data;
  try {
    content = JSON.parse(content);
    if (typeof content === "boolean") {
      content = String(content);
    }
  } catch (err) {
    // Handle the error case if necessary
  }
  var _ref3 = Getrules || {},
    rules = _ref3.rules,
    editable_fields = _ref3.editable_fields,
    save_mandatory_fields = _ref3.save_mandatory_fields,
    find_and_replace = _ref3.find_and_replace,
    hide_physical_link = _ref3.hide_physical_link,
    dropdown_data = _ref3.dropdown_data,
    symbol_find_replace = _ref3.symbol_find_replace,
    dependent_rule_all_data = _ref3.dependent_rule_all_data;
  var rule_arr = rules === null || rules === void 0 ? void 0 : rules[title];
  var onActionFieldError = function onActionFieldError(title, border) {
    return fielderror(rule_arr, content, editable_arr, "form", false, title, border);
  };
  var fieldValidationMessage = function fieldValidationMessage(border) {
    var _ref4 = onActionFieldError() || {},
      keys = _ref4.keys,
      messageShow = _ref4.messageShow;
    var errorMess = border ? messageShow === null || messageShow === void 0 ? void 0 : messageShow.length : errorSpan(messageShow);
    return keys !== "roundoff" ? keys !== "concat" ? onActionFieldError() : errorMess : errorMess;
  };
  var equalsCheck = function equalsCheck() {
    var a = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var b = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    if (a.length !== b.length) return false;
    for (var i = 0; i < a.length; i++) {
      if (a[i] !== b[i]) return false;
    }
    return true;
  };
  var handleOnChangeFields = function handleOnChangeFields(value, invalid) {
    var _ref5 = onActionFieldError() || {},
      keys = _ref5.keys,
      values = _ref5.values;
    var data = _toConsumableArray(editable_arr);
    if ((invalidForm === null || invalidForm === void 0 ? void 0 : invalidForm.includes(title)) && !["textArea", "input"].includes(input_type)) {
      var _window$getRegion, _original_data$title;
      var obj = (_window$getRegion = window.getRegion()) === null || _window$getRegion === void 0 ? void 0 : _window$getRegion.find(function (item) {
        return item.cls === title;
      });
      if (typeof value !== "object" && value !== original_data[title]) {
        window.onChangeRegion(_objectSpread({}, obj, {
          invalid: false,
          update_user: true
        }));
      } else if (typeof value === "object" && !equalsCheck((_original_data$title = original_data[title]) === null || _original_data$title === void 0 ? void 0 : _original_data$title.sort(), value === null || value === void 0 ? void 0 : value.sort())) {
        window.onChangeRegion(_objectSpread({}, obj, {
          invalid: false,
          update_user: true
        }));
      }
    }
    if (keys === "concat" || keys === "roundoff") {
      data[index].content = values;
    } else {
      data[index].content = value;
      if (invalid === "invalid") {
        var _window$getRegion2;
        var _obj = (_window$getRegion2 = window.getRegion()) === null || _window$getRegion2 === void 0 ? void 0 : _window$getRegion2.find(function (item) {
          return item.cls === title;
        });
        window.onChangeRegion(_objectSpread({}, _obj, {
          invalid: !data[index].invalid
        }));
        data[index].invalid = !data[index].invalid;
      }
    }
    setFormData(data);
  };
  var handleRulesApplyOnFoucsBlur = function handleRulesApplyOnFoucsBlur() {
    var _ref6 = onActionFieldError() || {},
      keys = _ref6.keys,
      values = _ref6.values;
    keys === "roundoff" ? handleOnChangeFields(values, false) : null;
    keys === "concat" ? handleOnChangeFields(values, false) : null;
    var find_replace_arr = (find_and_replace === null || find_and_replace === void 0 ? void 0 : find_and_replace[title]) || [];
    var string = values || content;
    if (keys === "concat") {
      string = values;
    }
    try {
      if (string) {
        for (var i = 0; i < (find_replace_arr === null || find_replace_arr === void 0 ? void 0 : find_replace_arr.length); i++) {
          var _string;
          string = (_string = string) === null || _string === void 0 ? void 0 : _string.replaceAll(find_replace_arr[i].search, find_replace_arr[i].replace);
        }
        var symbol_find_replace_rule = (symbol_find_replace === null || symbol_find_replace === void 0 ? void 0 : symbol_find_replace[title]) || {};
        var _ref7 = symbol_find_replace_rule || {},
          find_replace = _ref7.find_replace,
          symbol = _ref7.symbol;
        var symbol_rule_string = "";
        if ((find_replace === null || find_replace === void 0 ? void 0 : find_replace.length) && symbol_rule_string) {
          string = symbol_rule_string;
        }
        string = trimRule({
          rules_arr: rule_arr,
          content: string
        });
        handleOnChangeFields(string);
      }
    } catch (err) {
      console.log("handle_symbol_find_replace break", err);
    }
    if ((invalidForm === null || invalidForm === void 0 ? void 0 : invalidForm.includes(title)) && ["textArea", "input"].includes(input_type)) {
      var _window$getRegion3;
      var obj = (_window$getRegion3 = window.getRegion()) === null || _window$getRegion3 === void 0 ? void 0 : _window$getRegion3.find(function (item) {
        return item.cls === title;
      });
      if (typeof content !== "object" && content !== original_data[title]) {
        window.onChangeRegion(_objectSpread({}, obj, {
          invalid: false,
          update_user: true
        }));
      }
    }
  };
  var getDependentFields = dependent_rule_all_data === null || dependent_rule_all_data === void 0 ? void 0 : (_dependent_rule_all_d = dependent_rule_all_data[0]) === null || _dependent_rule_all_d === void 0 ? void 0 : (_dependent_rule_all_d2 = _dependent_rule_all_d.dependent_rule) === null || _dependent_rule_all_d2 === void 0 ? void 0 : _dependent_rule_all_d2[title];
  var getDropdown_data = dependent_rule_all_data === null || dependent_rule_all_data === void 0 ? void 0 : (_dependent_rule_all_d3 = dependent_rule_all_data[0]) === null || _dependent_rule_all_d3 === void 0 ? void 0 : _dependent_rule_all_d3.dependent_data;
  var getFieldContent = ((_ref8 = [].concat(_toConsumableArray(editable_arr), _toConsumableArray(customized_column_arr))) === null || _ref8 === void 0 ? void 0 : (_ref8$find = _ref8.find(function (item) {
    return item.title === getDependentFields;
  })) === null || _ref8$find === void 0 ? void 0 : _ref8$find.content) || "";
  var handledependentDropdown = function handledependentDropdown(event, detect, isDependent, title) {
    var update_Dependentvalue = function update_Dependentvalue(arr) {
      var editable = _toConsumableArray(editable_arr);
      var customize = _toConsumableArray(customized_column_arr);
      var editable_key = "";
      var customized_key = "";
      if (column_key === "editable_column") {
        editable_key = "editable";
        customized_key = "customized_column";
      } else if (column_key === "customized_column") {
        editable_key = "customized_column";
        customized_key = "editable";
      }
      editable.map(function (item, editable) {
        if (arr.includes(String(item.title))) {
          var data = _toConsumableArray(editable_arr);
          data[editable].content = "";
          setFormData(data);
        }
      });
      customize === null || customize === void 0 ? void 0 : customize.map(function (item, customizeIndex) {
        if (arr.includes(String(item.title))) {
          var data = _toConsumableArray(customized_column_arr);
          data[customizeIndex].content = "";
          setCustomize(data);
        }
      });
    };
    if (!detect && isDependent) {
      var _dependent_rule_all_d4;
      var dependentKeys = Object.keys((dependent_rule_all_data === null || dependent_rule_all_data === void 0 ? void 0 : (_dependent_rule_all_d4 = dependent_rule_all_data[0]) === null || _dependent_rule_all_d4 === void 0 ? void 0 : _dependent_rule_all_d4.dependent_rule) || {});
      update_Dependentvalue(dependentKeys);
    } else if (isDependent) {
      (function () {
        var _dependent_rule_all_d5;
        var d = dependent_rule_all_data === null || dependent_rule_all_data === void 0 ? void 0 : (_dependent_rule_all_d5 = dependent_rule_all_data[0]) === null || _dependent_rule_all_d5 === void 0 ? void 0 : _dependent_rule_all_d5.dependent_rule;
        var d1 = [];
        var current = title;
        var nextCheck = false;
        do {
          nextCheck = false;
          Object.keys(d).map(function (key) {
            if (d[key] === current) {
              nextCheck = true;
              d1.push(key);
              current = key;
            }
          });
        } while (nextCheck);
        update_Dependentvalue(d1);
      })();
    }
    handleOnChangeFields(event, false, event);
    if (!detect && isDependent) {
      var _dependent_rule_all_d6;
      var _dependentKeys = Object.keys((dependent_rule_all_data === null || dependent_rule_all_data === void 0 ? void 0 : (_dependent_rule_all_d6 = dependent_rule_all_data[0]) === null || _dependent_rule_all_d6 === void 0 ? void 0 : _dependent_rule_all_d6.dependent_rule) || {});
      update_Dependentvalue(_dependentKeys);
    }
  };
  var _ref9 = isNonMandatoryEditable({
      rules_arr: rule_arr,
      editable_arr: [].concat(_toConsumableArray(editable_arr), [customized_column_arr])
    }) || {},
    readOnly = _ref9.readOnly,
    valueExist = _ref9.valueExist;
  var handleInvalid = function handleInvalid(invalid) {
    handleOnChangeFields(content, "invalid");
  };
  var borderColor = (invalidForm === null || invalidForm === void 0 ? void 0 : invalidForm.includes(title)) && !invalid_show ? {
    border: "1px solid red",
    borderRadius: "6px"
  } : invalid_show && (updateForm === null || updateForm === void 0 ? void 0 : updateForm.includes(title)) ? {
    border: "1px solid green",
    borderRadius: "6px"
  } : {
    border: "none",
    borderRadius: "6px"
  };
  return access_block.includes(title) ? null : input_type === "label" ? /*#__PURE__*/React.createElement("div", {
    id: "image_ocr"
  }, /*#__PURE__*/React.createElement("span", {
    className: "font-MontSemiBold task_formlabel",
    style: {
      width: "80%",
      whiteSpace: "no",
      textOverflow: "ellipsis",
      overFlow: "hidden"
    }
  }, display_label), /*#__PURE__*/React.createElement(Typography, null, content)) : input_type === "textArea" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(AnnotationInput, {
    labelClass: "task_formlabel",
    isRequired: mandatory === "mandatory",
    rows: 3,
    title: display_label,
    id: display_label,
    value: content,
    fullWidth: true,
    onChange: function onChange(e) {
      handleOnChangeFields(e.target.value);
    },
    focused: true,
    onblur: function onblur() {
      return handleRulesApplyOnFoucsBlur();
    },
    readOnly: valueExist ? readOnly : false,
    invalid: invalid,
    invalid_show: invalid_show && content && ((_String = String(content)) === null || _String === void 0 ? void 0 : _String.length),
    handleInvalid: handleInvalid,
    style: borderColor
  }), ShowCount({
    rules_arr: rules === null || rules === void 0 ? void 0 : rules[display_label]
  }) && /*#__PURE__*/React.createElement("span", {
    style: {
      fontSize: "0.7rem"
    },
    className: "text-green-600 flex justify-start"
  }, String(content).length), fieldValidationMessage()) : input_type === "input" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(NormalInput, {
    onFocus: function onFocus() {
      return handleRulesApplyOnFoucsBlur();
    },
    labelClass: "task_formlabel",
    title: display_label,
    value: content,
    onChange: function onChange(e) {
      handleOnChangeFields(e.target.value);
    },
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    onblur: function onblur() {
      handleRulesApplyOnFoucsBlur();
    },
    count: false,
    isTooltip: true,
    readOnly: valueExist ? readOnly : false,
    invalid: invalid,
    invalid_show: invalid_show,
    handleInvalid: handleInvalid,
    style: borderColor
  }), ShowCount({
    rules_arr: rules === null || rules === void 0 ? void 0 : rules[display_label]
  }) && /*#__PURE__*/React.createElement("span", {
    style: {
      fontSize: "0.7rem"
    },
    className: "text-green-600 flex justify-start"
  }, String(content).length), fieldValidationMessage()) : input_type === "dependentDropdown" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: display_label,
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    invalid: invalid,
    invalid_show: invalid_show,
    handleInvalid: handleInvalid
  }), /*#__PURE__*/React.createElement("div", {
    style: borderColor
  }, /*#__PURE__*/React.createElement(CreatableSelect, {
    isSearchable: true,
    menuPosition: "fixed",
    menuPlacement: "auto",
    onChange: function onChange(e) {
      handledependentDropdown(e.value, getDependentFields, true, title);
    },
    placeholder: display_label,
    value: content && {
      value: content,
      label: content
    },
    options: getDependentFields ? (_getDropdown_data$get = getDropdown_data[getDependentFields]) === null || _getDropdown_data$get === void 0 ? void 0 : (_getDropdown_data$get2 = _getDropdown_data$get[getFieldContent]) === null || _getDropdown_data$get2 === void 0 ? void 0 : _getDropdown_data$get2.map(function (c) {
      return {
        value: c,
        label: c
      };
    }) : Object.keys((getDropdown_data === null || getDropdown_data === void 0 ? void 0 : getDropdown_data[title]) || {}).map(function (c) {
      return {
        value: c,
        label: c
      };
    })
  }))) : input_type === "dropdown" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: display_label,
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    invalid: invalid,
    invalid_show: invalid_show,
    handleInvalid: handleInvalid
  }), /*#__PURE__*/React.createElement("div", {
    style: borderColor
  }, /*#__PURE__*/React.createElement(CreatableSelect, {
    isSearchable: true,
    menuPosition: "fixed",
    menuPlacement: "auto",
    onChange: function onChange(e) {
      handleOnChangeFields(e.value, getDependentFields, true, title);
    },
    placeholder: display_label,
    value: content && {
      value: content,
      label: content
    },
    options: (_LocalStorage$get_dro = LocalStorage.get_dropdown()) === null || _LocalStorage$get_dro === void 0 ? void 0 : (_LocalStorage$get_dro2 = _LocalStorage$get_dro[title]) === null || _LocalStorage$get_dro2 === void 0 ? void 0 : _LocalStorage$get_dro2.map(function (c) {
      return {
        label: c.label,
        value: c.value
      };
    })
  }))) : input_type === "radio" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: display_label,
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    invalid: invalid,
    invalid_show: invalid_show,
    handleInvalid: handleInvalid
  }), /*#__PURE__*/React.createElement(FormControl, null, /*#__PURE__*/React.createElement(RadioGroup, {
    "aria-labelledby": "demo-radio-buttons-group-label",
    name: "radio-buttons-group",
    value: content,
    onChange: function onChange(e) {
      return handleOnChangeFields(e.target.value);
    }
  }, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 2,
    direction: "row"
  }, other_value === null || other_value === void 0 ? void 0 : other_value.map(function (item) {
    var color = !invalid_show && invalidForm.includes(title) && (original_data === null || original_data === void 0 ? void 0 : original_data[title]) === item.value ? "red" : invalid_show && updateForm.includes(title) && (original_data === null || original_data === void 0 ? void 0 : original_data[title]) === item.value ? "green" : "#005f86";
    return /*#__PURE__*/React.createElement(Grid, {
      item: true,
      lg: 6,
      md: 6,
      xs: 6,
      key: item.value
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      value: item.value,
      control: /*#__PURE__*/React.createElement(Radio, {
        sx: {
          color: color,
          "&.Mui-checked": {
            color: color
          }
        }
      }),
      title: item.label,
      label: /*#__PURE__*/React.createElement("p", {
        style: {
          maxWidth: "120px",
          textOverflow: "ellipsis",
          overflow: "hidden",
          whiteSpace: "noWrap"
        }
      }, item.label)
    }));
  }))))) : input_type === "checkbox" ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TaskFormLabel, {
    display_label: display_label,
    isRequired: (save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title)) || mandatory === "mandatory",
    isAstrick: save_mandatory_fields === null || save_mandatory_fields === void 0 ? void 0 : save_mandatory_fields.includes(title),
    invalid: invalid,
    invalid_show: invalid_show,
    handleInvalid: handleInvalid
  }), /*#__PURE__*/React.createElement(FormControl, {
    variant: "standard",
    component: "fieldset"
  }, /*#__PURE__*/React.createElement(FormGroup, null, /*#__PURE__*/React.createElement(Grid, {
    container: true,
    spacing: 2,
    direction: "row"
  }, other_value === null || other_value === void 0 ? void 0 : other_value.map(function (item) {
    var _original_data$title2, _original_data$title3, _content;
    var color = !invalid_show && (original_data === null || original_data === void 0 ? void 0 : (_original_data$title2 = original_data[title]) === null || _original_data$title2 === void 0 ? void 0 : _original_data$title2.includes(item.value)) ? "red" : invalid_show && updateForm.includes(title) && (original_data === null || original_data === void 0 ? void 0 : (_original_data$title3 = original_data[title]) === null || _original_data$title3 === void 0 ? void 0 : _original_data$title3.includes(item.value)) ? "green" : "#005f86";
    return /*#__PURE__*/React.createElement(Grid, {
      item: true,
      lg: 6,
      md: 6,
      xs: 6,
      key: item.value
    }, /*#__PURE__*/React.createElement(FormControlLabel, {
      control: /*#__PURE__*/React.createElement(Checkbox, {
        name: item.vlaue,
        checked: (_content = content) === null || _content === void 0 ? void 0 : _content.includes(item.value),
        sx: {
          color: color,
          "&.Mui-checked": {
            color: color
          }
        },
        onChange: function onChange(e) {
          var a = content ? typeof content === "string" ? [content].concat() : _toConsumableArray(content) : [];
          var checkboxIndex = a.indexOf(item.value);
          if (checkboxIndex === -1) {
            a.push(item.value);
          } else {
            a.splice(checkboxIndex, 1);
          }
          handleOnChangeFields(a);
        }
      }),
      label: /*#__PURE__*/React.createElement("p", {
        style: {
          maxWidth: "120px",
          textOverflow: "ellipsis",
          overflow: "hidden",
          whiteSpace: "noWrap"
        }
      }, item.label)
    }));
  }))))) : null;
}
export default FormOCR;